/***************************************************************************
 *            scan_config_file.c
 *
 *  Fri Oct 24 11:28:42 2003
 *  Copyright  2003  Phil Kett
 *  pkett@genesis-midi.com
 ****************************************************************************/

#include "../include/remsync.h"

int
scan_config_file (char *filename)
{
	FILE *fp;
	int result;
	char temp_port[BIG_BUF];
	char temp_server[BIG_BUF];
	char temp_debug[BIG_BUF];
	char temp_deletes[BIG_BUF];
	char temp_statistics[BIG_BUF];
	char temp_newer[BIG_BUF];
#ifdef HAVE_FNOTIFY
	char temp_monitor[BIG_BUF];
#endif
	
	fp = fopen(filename, "r");
	result = read_config(fp, "source", conf.source);
	strip_space(conf.source);
	checkslash(conf.source);
	result = read_config(fp, "pidfile", conf.pidfile);
	strip_space(conf.pidfile);
	result = read_config(fp, "destination", conf.dest);
	strip_space(conf.dest);
	checkslash(conf.dest);
	result = read_config(fp, "notify", conf.notify);
	strip_space(conf.notify);
	checkslash(conf.notify);
	result = read_config(fp, "ip_list", conf.ip_list);
	strip_space(conf.ip_list);
	result = read_config(fp, "hostname", conf.host);
	strip_space(conf.host);
#ifdef HAVE_FNOTIFY
	result = read_config(fp, "monitor", temp_monitor);
	if (result == 0) {
		if (strcasecmp(temp_monitor, "yes") == 0) {
			conf.monitor = 1;
		}
	}
#endif
	result = read_config(fp, "debug", temp_debug);
	if (result == 0) {
		if (strcasecmp(temp_debug, "yes") == 0) {
			conf.debug = 1;
		}
	}
	result = read_config(fp, "deletes", temp_deletes);
	if (result == 0) {
		if (strcasecmp(temp_debug, "yes") == 0) {
			conf.deletes = 1;
		}
	}
	result = read_config(fp, "statistics", temp_statistics);
	if (result == 0) {
		if (strcasecmp(temp_statistics, "yes") == 0) {
			conf.stats = 1;
		}
	}
	result = read_config(fp, "newer", temp_newer);
	if (result == 0) {
		if (strcasecmp(temp_newer, "yes") == 0) {
			conf.newer = 1;
		}
	}
		
	result = read_config(fp, "port", temp_port);
	if (result == 0) {
		strip_space(temp_port);
		conf.port = atoi(temp_port);
	}
	result = read_config(fp, "server", temp_server);
	if (result == 0) {
		if (strcasecmp(temp_server, "yes") == 0) {
			conf.server = 1;
		}
	}
	fclose(fp);
	return 0;
}

int
read_config (FILE *fp, char *keyword, char *value)
{
	char str[BIG_BUF];
	int len;

	for (;;)
	{
		fgets (str, BIG_BUF, fp);
		if (feof (fp))
		{
			rewind(fp);
			return(-1);
		}
		len = strlen (str);
		if (strncasecmp (keyword, str, strlen (keyword)) == 0)
		{
			if (str[len - 1] == '\n')
			{
				str[--len] = 0;
			}
			snprintf (value, BIG_BUF, "%s", &str[strlen (keyword) + 1]);
			break;
		}
	}
	rewind (fp);
	return 0;
}

void dump_config () {
	if (conf.debug) {
		printf("Hostname:\t%s\n", conf.host);
		printf("Source:\t%s\n", conf.source);
		printf("Dest:\t%s\n", conf.dest);
		printf("IP_List:\t%s\n", conf.ip_list);
		printf("Port:\t%d\n", conf.port);
		printf("Server:\t%d\n", conf.server);
		printf("Remote:\t%d\n", conf.remote);
#ifdef HAVE_FNOTIFY
		printf("Monitor:\t%s\n", conf.monitor);
#endif
		printf("Newer:\t%d\n", conf.newer);
	}
	
}
